<?php
/**
 * Статусы заказа
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    5.4
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2014 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_orderstatus
 */
class Shop_admin_orderstatus extends Frame_admin
{
	replace public $variables = array (
		'main' => array (
			'name' => array(
				'type' => 'text',
				'name' => 'Название',
				'multilang' => true,
			),
			'status' => array(
				'type' => 'select',
				'name' => 'Действие',
				'help' => 'Действие, при котором статус устанавливается. Действие определяет цвет статуса в панели администрирования.',
			),
			'subject' => array(
				'type' => 'text',
				'name' => 'Тема письма',			
				'help'	=> 'В теме письма можно использовать данные заказа %title тема письма из настроек, %url адрес сайта, %order номер заказа'
			),
			'message' => array(
				'type' => 'editor',
				'name' => 'Текст сообщения на e-mail пользователю',
				'help' => 'В тексте можно использовать данные заказа %title тема письма из настроек, %url адрес сайта, %order номер заказа, %status название статуса заказа, %fio - ФИО заказчика',
				'multilang' => false,
			),
			'send_files' => array(
				'type' => 'checkbox',
				'name' => 'Отсылать приложенные файлы к заказу',
				'help' => 'К письму будет приложены файлы прикрепленные к заказу в админке. Например накладные транспортной компании или иная документация, сканы службених писем..',
			),
			'color' => array(
				'type' => 'text',
				'name' => 'Цвет',
				'help' => 'Цвет, которым будет выделен статус в списке заказов и в личном кабинете пользователя. Пример: red или #ff0000.',
			),
			'count_minus' => array(
				'type' => 'checkbox',
				'name' => 'Списание товара',
				'help' => 'При установке статуса происходит уменьшение количества товара, указанного в заказе, если товары еще не списаны. Если значение не установлено, то при установке статуса списание товаров будет отменено, количество товара на складе увеличиться.',
			),
			'send_mail' => array(
				'type' => 'checkbox',
				'name' => 'Отсылать письмо',
				'help' => 'Если этот параметр не отмечен, то письмо посылаться не будет',
				'default' => true,
			),
			'sort' => array(
				'type' => 'function',
				'name' => 'Сортировка: установить перед',
				'help' => 'Редактирование порядка следования поля в списке.',
			),
			
		),
	);
}