<?php
/**
 * Подключение модуля «Магазин» для работы с заказами
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    5.4
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2014 OOO «Диафан» (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

class Shop_inc_order extends Diafan
{
	/**
	 * Отправляет уведомления об изменении статуса заказа
	 *
	 * @param integer $order_id номер заказа
	 * @param integer $status ID статуса заказа
	 * @return void
	 */
	new public function send_mail_change_status($order_id, $status_arr)
	{
		Custom::inc('includes/mail.php');
		$email = ($this->diafan->configmodules("emailconf", 'shop')
				   && $this->diafan->configmodules("email", 'shop')
				   ? $this->diafan->configmodules("email", 'shop') : '' );

		$lang_id = DB::query_result("SELECT lang_id FROM {shop_order} WHERE id=%d", $order_id);
		if(! $lang_id)
		{
			$lang_id = $this->diafan->_languages->site;
		}
		$body=$status_arr['message'];
		$subj=$status_arr['subject'];
		$send=$status_arr['send_files'];
		$send_mail=$status_arr['send_mail'];
		if($send_mail==0)return; 
		if(trim(strip_tags($subj))=='')
			$subj=$this->diafan->configmodules('subject_change_status', 'shop');
		if(trim(strip_tags($body))=='')
		   $body=$this->diafan->configmodules('message_change_status', 'shop');
		   
	 	$user_mail = DB::query_result(
				"SELECT value FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.type='email'"
				." WHERE e.element_id=%d", $order_id
			);
		$f = DB::query_result(
				"SELECT value FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.info='lastname'"
				." WHERE e.element_id=%d", $order_id
			);
		$i = DB::query_result(
				"SELECT value FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.info='firstname'"
				." WHERE e.element_id=%d", $order_id
			);
		$o = DB::query_result(
				"SELECT value FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.info='fathersname'"
				." WHERE e.element_id=%d", $order_id
			);
		$name =  DB::query_result(
				"SELECT value FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.info='name'"
				." WHERE e.element_id=%d", $order_id
			);
		$fio="$f $i $o";
		if($user_mail)
		{			
			$status_name = $status_arr['name'.$lang_id];
			$replace=array(
				 '%title'=>TITLE,
				 '%url'=>BASE_URL,
				 '%order'=>$order_id,
				 '%status'=>$status_name,
				 '%fio'=>$fio,
				 '%name'=>$name
			);
			$subject = $this->replace_params($subj,$order_id,$replace);
			$message = $this->replace_params($body,$order_id,$replace);

			if($send==1)
				$this->send_naklad($user_mail, $subject, $message,  $email, $order_id);
			else send_mail($user_mail, $subject, $message,  $email);
		}
	}

	new private function replace_params($subject,$order_id,$replace)
	{

		preg_match_all('/%param(\d{1,3})/sm', $subject, $result, PREG_PATTERN_ORDER);	
		if(!empty($result) and !empty($result[1]))
		{			
			 $params=DB::query_fetch_all(
				"SELECT e.value, p.* FROM {shop_order_param_element} AS e"
				." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.id in("
				.implode(',',$result[1]).")"
				." WHERE e.element_id=%d", $order_id
			);
			foreach($params as $param)
			{
				if($param['type']=='select')
						$value=DB::query_result("SELECT [name] FROM {shop_order_param_select} WHERE id=%d", $param['value']);
				else $value=$param['value'];
				if(!isset($replace['%param'.$param['id']]))
					$replace['%param'.$param['id']]=$value;
			}
			
		}
		$subject=strtr($subject,$replace);
		return $subject;
	}
	
	new private function send_naklad($recipient, $subject, $body, $from = '',$order_id)
	{
		Custom::inc('plugins/class.phpmailer.php');

		$mail = new PHPMailer();

		if (defined('SMTP_MAIL') && SMTP_MAIL && SMTP_HOST && SMTP_LOGIN && SMTP_PASSWORD)
		{
			$mail->IsSMTP(); // telling the class to use SMTP
			//$mail->SMTPSecure='ssl';
			$mail->Host       = SMTP_HOST;  // SMTP server
			$mail->SMTPDebug  = MOD_DEVELOPER ? 1 : 0; // enables SMTP debug information (for testing)
													   // 1 = errors and messages
													   // 2 = messages only
			$mail->SMTPAuth   = true;                  // enable SMTP authentication
			if (SMTP_PORT)
			{
				$mail->Port   = SMTP_PORT;          // set the SMTP port for the GMAIL server
			}
			$mail->Username   = SMTP_LOGIN;    // SMTP account username
			$mail->Password   = SMTP_PASSWORD; // SMTP account password
		}

		$mail->SetFrom($from ? $from : EMAIL_CONFIG, TITLE);
		$mail->Subject = $subject;
		$mail->MsgHTML($body);

		if (is_array($recipient))
		{
			foreach ($recipient as $to)
			{
				$mail->AddAddress($to);
			}
		}
		elseif (strpos($recipient, ',') !== false)
		{
			$recipients = explode(',', $recipient);
			foreach ($recipients as $r)
			{
				$mail->AddAddress(trim($r));
			}
		}
		else
		{
			$mail->AddAddress($recipient);
		}
		$param_id=DB::query_result("SELECT id FROM {shop_order_param} where `type`='attachments' and `required`='0' and `show_in_form`='0' and `show_in_form_register`='0' and `show_in_form_one_click`='0' and `trash`='0'");
		
		// прикрепление файлов
		$att = DB::query_fetch_all("SELECT id, name, extension,`size` FROM {attachments} where `module_name`='shop_order' and param_id=%d and element_id=%d and trash='0' ",$param_id, $order_id);
		
		if(!empty($att))
		{
			foreach($att as $file)
			{
				copy(ABSOLUTE_PATH.'userfiles/shop_order/files/'.$file['id'],ABSOLUTE_PATH.'tmp/'.$file['name']);
				$mail->AddAttachment(ABSOLUTE_PATH.'tmp/'.$file['name'], $file['name']); 
			}
		$mailssend = $mail->Send();
		}
		if(!empty($att))
			foreach($att as $file)
			{
				unlink(ABSOLUTE_PATH.'tmp/'.$file['name']);
				
			}				
		return $mailssend;		
	}
	
	/**
	 * Установка статуса
	 * 
	 * @param array $order информация о заказе
	 * @param array $status информация о статусе заказа
	 * @return void
	 */
	replace public function set_status($order, $status)
	{
		//отправить ссылки на купленные файлы, если они есть
		if ($status["status"] == '1' && $this->diafan->configmodules("use_non_material_goods", "shop"))
		{
			$shop_ids = DB::query_fetch_value("SELECT * FROM {shop_order_goods} WHERE order_id=%d", $order["id"], "good_id");
			//выполнить необходимые операции, с нематериальными товарами
			$this->shop_file_sale($order["id"], $shop_ids);
		}

		$count_minus = $order["count_minus"];
		if ($status["count_minus"] && ! $order["count_minus"] && $this->diafan->configmodules("use_count_goods", "shop"))
		{
			$count_minus = 1;
		}
		if (! $status["count_minus"] && $order["count_minus"] && $this->diafan->configmodules("use_count_goods", "shop"))
		{
			$count_minus = 0;
		}
		

		DB::query("UPDATE {shop_order} SET `status`='%d', status_id=%d, count_minus='%d' WHERE id=%d", $status["status"], $status["id"], $count_minus, $order["id"]);
		
		if($status["send_mail"])
		{
			$user_mail = DB::query_result(
					"SELECT value FROM {shop_order_param_element} AS e"
					." INNER JOIN {shop_order_param} AS p ON p.id=e.param_id AND p.type='email'"
					." WHERE e.element_id=%d", $order["id"]
				);
			if($user_mail)
			{	
				$this->send_mail_change_status($order["id"],$status);
			}
		}

		if ($status["count_minus"] && ! $order["count_minus"] && $this->diafan->configmodules("use_count_goods", "shop"))
		{
			$rows = DB::query_fetch_all("SELECT * FROM {shop_order_goods} WHERE order_id=%d", $order["id"]); 
			foreach ($rows as $row)
			{
				if ($row["count_goods"])
				{
					$params = DB::query_fetch_key_value("SELECT * FROM {shop_order_goods_param} WHERE order_goods_id=%d", $row["id"], "param_id", "value");
					$row_price = $this->diafan->_shop->price_get($row["good_id"], $params, false);
					$count = $row_price['count_goods'] > $row["count_goods"] ? $row_price['count_goods'] - $row["count_goods"] : 0;
					// уменьшаем количество товаров на складе
					DB::query("UPDATE {shop_price} SET count_goods=%d WHERE price_id=%d", $count, $row_price["price_id"]);
				}
			}
		}

		if (! $status["count_minus"] && $order["count_minus"] && $this->diafan->configmodules("use_count_goods", "shop"))
		{
			$rows = DB::query_fetch_all("SELECT * FROM {shop_order_goods} WHERE order_id=%d", $order["id"]); 
			foreach ($rows as $row)
			{
				if ($row["count_goods"])
				{
					$params = DB::query_fetch_key_value("SELECT * FROM {shop_order_goods_param} WHERE order_goods_id=%d", $row["id"], "param_id", "value");
					$row_price = $this->diafan->_shop->price_get($row["good_id"], $params, false);
					// увеличиваем количество товаров на складе
					DB::query("UPDATE {shop_price} SET count_goods=%d WHERE price_id=%d", $row_price['count_goods'] + $row["count_goods"], $row_price["price_id"]);
				}
			}
		}
	}
}